import * as React from 'react';
import { rootProjectionNode } from './node/HTMLProjectionNode.js';

function useInstantLayoutTransition() {
    var startTransition = React.useCallback(function (cb) {
        if (!rootProjectionNode.current)
            return;
        rootProjectionNode.current.isUpdating = false;
        rootProjectionNode.current.blockUpdate();
        cb === null || cb === void 0 ? void 0 : cb();
    }, []);
    return startTransition;
}

export { useInstantLayoutTransition };
