import * as React from 'react';
import { rootProjectionNode } from './node/HTMLProjectionNode.js';

function useResetProjection() {
    var reset = React.useCallback(function () {
        var root = rootProjectionNode.current;
        if (!root)
            return;
        root.clearMeasurements();
        root.sharedNodes.clear();
    }, []);
    return reset;
}

export { useResetProjection };
