import { TransformPoint } from "../geometry/types";
import { IProjectionNode } from "./types";
export declare const rootProjectionNode: {
    current: IProjectionNode | undefined;
};
export declare function measureViewportBox(instance: HTMLElement, transformPoint?: TransformPoint): import("../geometry/types").Box;
export declare const HTMLProjectionNode: {
    new (id: number | undefined, latestValues?: import("../../render/types").ResolvedValues, parent?: IProjectionNode<unknown> | undefined): {
        id: number | undefined;
        instance: HTMLElement;
        root: IProjectionNode<unknown>;
        parent?: IProjectionNode<unknown> | undefined;
        path: IProjectionNode<unknown>[];
        children: Set<IProjectionNode<unknown>>;
        options: import("./types").ProjectionNodeOptions;
        snapshot: import("./types").Snapshot | undefined;
        layout: import("../geometry/types").Box | undefined;
        targetLayout?: import("../geometry/types").Box | undefined;
        layoutCorrected: import("../geometry/types").Box;
        targetDelta?: import("../geometry/types").Delta | undefined;
        target?: import("../geometry/types").Box | undefined;
        targetWithTransforms?: import("../geometry/types").Box | undefined;
        projectionDelta?: import("../geometry/types").Delta | undefined;
        projectionDeltaWithTransform?: import("../geometry/types").Delta | undefined;
        scroll?: import("../geometry/types").Point | undefined;
        isLayoutDirty: boolean;
        updateBlocked: boolean;
        isUpdating: boolean;
        needsReset: boolean;
        shouldResetTransform: boolean;
        treeScale: import("../geometry/types").Point;
        resumeFrom?: IProjectionNode<unknown> | undefined;
        resumingFrom?: IProjectionNode<unknown> | undefined;
        latestValues: import("../../render/types").ResolvedValues;
        hasTargetBoxUpdated: boolean;
        eventHandlers: Map<import("./types").LayoutEvents, import("../../utils/subscription-manager").SubscriptionManager<any>>;
        nodes?: import("../..").FlatTree | undefined;
        depth: number;
        projectionTransform: string;
        addEventListener(name: import("./types").LayoutEvents, handler: any): () => void;
        notifyListeners(name: import("./types").LayoutEvents, ...args: any): void;
        hasListeners(name: import("./types").LayoutEvents): boolean;
        potentialNodes: Map<number, IProjectionNode<unknown>>;
        registerPotentialNode(id: number, node: IProjectionNode<unknown>): void;
        mount(instance: HTMLElement, isLayoutDirty?: boolean): void;
        unmount(): void;
        blockUpdate(): void;
        unblockUpdate(): void;
        startUpdate(): void;
        willUpdate(shouldNotifyListeners?: boolean): void;
        didUpdate(): void;
        scheduleUpdateProjection(): void;
        updateProjection: () => void;
        updateSnapshot(): void;
        updateLayout(): void;
        updateScroll(): void;
        resetTransform(): void;
        measure(): import("../geometry/types").Box;
        removeElementScroll(box: import("../geometry/types").Box): import("../geometry/types").Box;
        removeTransform(box: import("../geometry/types").Box): import("../geometry/types").Box;
        setTargetDelta(delta: import("../geometry/types").Delta): void;
        setOptions(options: import("./types").ProjectionNodeOptions): void;
        clearMeasurements(): void;
        resolveTargetDelta(): void;
        calcProjection(): void;
        isVisible: boolean;
        hide(): void;
        show(): void;
        scheduleRender(): void;
        animationProgress: number;
        animationValues?: import("../../render/types").ResolvedValues | undefined;
        currentAnimation?: import("../..").AnimationPlaybackControls | undefined;
        mixTargetDelta: (progress: number) => void;
        setAnimationOrigin(delta: import("../geometry/types").Delta): void;
        startAnimation(options: import("../..").AnimationOptions<number>): void;
        finishAnimation(): void;
        applyTransformsToTarget(): void;
        sharedNodes: Map<string, import("../shared/stack").NodeStack>;
        registerSharedNode(layoutId: string, node: IProjectionNode<unknown>): void;
        isLead(): boolean;
        getLead(): IProjectionNode<unknown> | any;
        getPrevLead(): IProjectionNode<unknown> | undefined;
        getStack(): import("../shared/stack").NodeStack | undefined;
        promote({ needsReset, transition, }?: {
            needsReset?: boolean | undefined;
            transition?: import("../..").Transition | undefined;
        }): void;
        relegate(): boolean;
        resetRotation(): void;
        getProjectionStyles(): import("../../render/types").ResolvedValues;
        clearSnapshot(): void;
    };
};
